ZWrtParser Class Reference documentation

ZWrtParser Class Referencefinal

the main class to read a ZWrite file More...

`#include <ZWrtParser.hxx>`

Inheritance diagram for ZWrtParser:

## Public Member Functions
| ZWrtParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~ZWrtParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches)
void | newPage (int number)
| adds a new page
bool | sendHeaderFooter (bool header)
| try to send the header/footer
bool | createZones ()
| finds the different objects zones
bool | readBarState (MWAWEntry const &entry)
| read the bar state
bool | readHTMLPref (MWAWEntry const &entry)
| read the html export pref
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo block
bool | readCPRT (MWAWEntry const &entry)
| try to read a xml printinfo zone
bool | readSectionRange (MWAWEntry const &entry)
| read the section range block
bool | readWindowPos (MWAWEntry const &entry)
| read the window position
bool | readUnknownZone (MWAWEntry const &entry)
| read a unknown block
bool | readCPos (MWAWEntry const &entry)
| read a cursor position in a section?
bool | readSLen (MWAWEntry const &entry)
| read a section length ?
bool | getFieldList (MWAWEntry const &entry, std::vector< ZWField > &list)
| returns a list of field
MWAWInputStreamPtr | rsrcInput ()
| return the input input
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< ZWrtParserInternal::State > | m_state
| the state
std::shared_ptr< ZWrtText > | m_textParser
| the text parser

## Friends
class | ZWrtParserInternal::SubDocument
class | ZWrtText

## Detailed Description

the main class to read a ZWrite file

## Constructor & Destructor Documentation

## ◆ ZWrtParser()

ZWrtParser::ZWrtParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~ZWrtParser()

ZWrtParser::~ZWrtParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool ZWrtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse(), and ZWrtText.

## ◆ createDocument()

void ZWrtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse(), and ZWrtText.

## ◆ createZones()

bool ZWrtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse(), and ZWrtText.

## ◆ getFieldList()

bool ZWrtParser::getFieldList | ( | MWAWEntry const & | entry,
|  | std::vector< ZWField > & | list )
| protected

returns a list of field

Referenced by readBarState(), readCPos(), readHTMLPref(), readPrintInfo(), readSLen(), readUnknownZone(), readWindowPos(), and ZWrtText.

## ◆ getPageLeftTop()

MWAWVec2f ZWrtParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

Referenced by ZWrtText.

## ◆ init()

void ZWrtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by ZWrtParser(), and ZWrtText.

## ◆ newPage()

void ZWrtParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by ZWrtText.

## ◆ parse()

void ZWrtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by ZWrtText.

## ◆ readBarState()

bool ZWrtParser::readBarState | ( | MWAWEntry const & | entry | ) |
| protected

read the bar state

Referenced by createZones(), and ZWrtText.

## ◆ readCPos()

bool ZWrtParser::readCPos | ( | MWAWEntry const & | entry | ) |
| protected

read a cursor position in a section?

Referenced by createZones(), and ZWrtText.

## ◆ readCPRT()

bool ZWrtParser::readCPRT | ( | MWAWEntry const & | entry | ) |
| protected

try to read a xml printinfo zone

Referenced by createZones(), and ZWrtText.

## ◆ readHTMLPref()

bool ZWrtParser::readHTMLPref | ( | MWAWEntry const & | entry | ) |
| protected

read the html export pref

Referenced by createZones(), and ZWrtText.

## ◆ readPrintInfo()

bool ZWrtParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |
| protected

read a PrintInfo block

Referenced by createZones(), and ZWrtText.

## ◆ readSectionRange()

bool ZWrtParser::readSectionRange | ( | MWAWEntry const & | entry | ) |
| protected

read the section range block

Referenced by createZones(), and ZWrtText.

## ◆ readSLen()

bool ZWrtParser::readSLen | ( | MWAWEntry const & | entry | ) |
| protected

read a section length ?

Referenced by createZones(), and ZWrtText.

## ◆ readUnknownZone()

bool ZWrtParser::readUnknownZone | ( | MWAWEntry const & | entry | ) |
| protected

read a unknown block

Referenced by createZones(), and ZWrtText.

## ◆ readWindowPos()

bool ZWrtParser::readWindowPos | ( | MWAWEntry const & | entry | ) |
| protected

read the window position

Referenced by createZones(), and ZWrtText.

## ◆ rsrcAscii()

libmwaw::DebugFile & ZWrtParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readBarState(), readCPos(), readCPRT(), readHTMLPref(), readPrintInfo(), readSectionRange(), readSLen(), readUnknownZone(), readWindowPos(), and ZWrtText.

## ◆ rsrcInput()

MWAWInputStreamPtr ZWrtParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by getFieldList(), readBarState(), readCPos(), readCPRT(), readHTMLPref(), readPrintInfo(), readSectionRange(), readSLen(), readUnknownZone(), readWindowPos(), sendHeaderFooter(), and ZWrtText.

## ◆ sendHeaderFooter()

bool ZWrtParser::sendHeaderFooter | ( | bool | header | ) |
| protected

try to send the header/footer

Referenced by ZWrtParserInternal::SubDocument::parse(), and ZWrtText.

## Friends And Related Symbol Documentation

## ◆ ZWrtParserInternal::SubDocument

friend class ZWrtParserInternal::SubDocument
| friend

## ◆ ZWrtText

friend class ZWrtText
| friend

Referenced by init(), and ZWrtText.

## Member Data Documentation

## ◆ m_state

std::shared_ptr<ZWrtParserInternal::State> ZWrtParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), getPageLeftTop(), init(), newPage(), and ZWrtParser().

## ◆ m_textParser

std::shared_ptr<ZWrtText> ZWrtParser::m_textParser
| protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), sendHeaderFooter(), and ZWrtParser().

The documentation for this class was generated from the following files:

- ZWrtParser.hxx
- ZWrtParser.cxx